<template>
    <component :is="component" @input="handleInput" :name="name" :value.prop="value" v-bind="attr">
        <slot />
    </component>
</template>

<script>
export default {
  name: 'Field',
  props: {
    component: {
      type: String,
      default: 'input'
    },
    name: String,
    onChange: Function
  },
  inject: ['handleChange', 'values', 'validationSchema'],
  methods: {
    handleInput: function(e) {
      e.preventDefault();
      this.handleChange(e);

      if(typeof this.onChange !== 'undefined')
        this.onChange(e);
    }
  },
  computed: {
    value() {
      return this.values()[this.name]
    },
    attr() {
      const attrs = {...this.$attrs};
      if(this.component == 'input' && ['radio', 'checkbox'].includes(attrs.type)){
        attrs.checked = this.value;
      }

      return attrs;
    }
  }
}
</script>